package jp.co.nec.ome.text;

//*****************************************************************************
/**
 * ̃tH[}bgNXłB<BR>
 * tH[}bg@\񋟂܂B<BR>
 * {NXstatic\bĥ݂ō\ACX^X쐬܂B<BR>
 * <P>
 * <B>gp@F</B><BR>
 * <BLOCKQUOTE><PRE>
 * //HTMLLqꂽ̃^uďo͂܂B
 * //̏ꍇAo͌ʂ"&amp;lt;HTML&amp;gt;&amp;lt;/HTML&amp;gt;"ƂȂ܂B
 * System.out.println(OmStringFormat.replaceTag("&lt;HTML&gt;&lt;/HTML&gt;"));
 * </PRE></BLOCKQUOTE>
 * <P>
 * <BLOCKQUOTE><PRE>
 * //JIS2004ǉȂǂ̃VtgJISŕ\łȂuďo͂܂B
 * //̏ꍇAo͌ʂ"XO"ƂȂ܂B(́̕uXOv̕ʎ)
 * System.out.println(OmStringFormat.replaceNotSJISCharacter("X&#X9dd7;O", ""));
 * </PRE></BLOCKQUOTE>
 * <P>
 * @author  Youichi Tokuda
 * @version $Revision:   5.3  $   $Date:   31 May 2007 14:30:00  $
 * @since   OpenMeisterEnterprise/EF 2.2
 */
//*****************************************************************************
public class OmStringFormat {

  //***************************************************************************
  //RXgN^
  //***************************************************************************

  //***************************************************************************
  /**
   * {NX̓CX^X𐶐܂B<BR>
   */
  //***************************************************************************
  protected OmStringFormat() {
  }

  //***************************************************************************
  //public\bh
  //***************************************************************************

  //***************************************************************************
  /**
   * HTMLɂ郁^u܂B
   * @param argHTMLString HTML
   * @return u̕
   */
  //***************************************************************************
  public static String replaceTag(String argHTMLString) {

    //null̏ꍇA󕶎ɒuĕԋp
    if (argHTMLString == null) {
      return "";
    }

    //u̕i[邽߂̃obt@
    StringBuffer planeString = new StringBuffer();

    //ꕶ`FbN
    for (int i0 = 0; i0 < argHTMLString.length(); i0++) {
      char originalCharacter = argHTMLString.charAt(i0);
      switch (originalCharacter) {
        case '<':
          planeString.append("&lt;");
          break;
        case '>':
          planeString.append("&gt;");
          break;
        case '\"':
          planeString.append("&quot;");
          break;
        case '&':
          planeString.append("&amp;");
          break;
        case '\'':
          planeString.append("&#39;");
          break;
        default:
          planeString.append(originalCharacter);
      }
    }
    return planeString.toString();
  }

  //***************************************************************************
  /**
   * Ώە񒆂JIS2004ǉȂǂShift_JIS(MS932)ŕ\łȂ
   * lQƕ܂ނ𔻒肵܂B
   * @param argOriginalString Ώە
   * @return true:܂<BR>
   *         false:܂܂Ȃ
   */
  //***************************************************************************
  public static boolean containsNotSJISCharacter(String argOriginalString) {
    if (argOriginalString != null && replaceNotSJISCharacter(argOriginalString, null) == null) {
      return true;
    }
    return false;
  }

  //***************************************************************************
  /**
   * JIS2004ǉȂǂShift_JIS(MS932)ŕ\łȂ)
   * ܂܂Ăꍇ̕w̕Œu܂B<BR>
   * ɐlQƕ̕ϊs܂B<BR>
   * lQƕShift_JIS(MS932)ŕ\\ȏꍇ
   * w肳ꂽuł͂ȂQƂĂ{̕ɕϊ܂B
   * @param argOriginalString Ώە
   * @param argReplaceCharacter uw蕶()
   * @return u̕Ԃ܂B<BR>
   *         uSsvȏꍇ͌̂̕܂ܕԂ܂B<BR>
   *         uw蕶null̏ꍇŎۂɂ͒uKvȏꍇnullԂ܂B
   */
  //***************************************************************************
  public static String replaceNotSJISCharacter(String argOriginalString, String argReplaceCharacter) {
    byte buffer[];
    char current;
    if (argOriginalString == null) return null;
    int len = argOriginalString.length();
    StringBuffer target = null;
    if (argReplaceCharacter != null) {
      //ŒƂĂƂ̕񒷂̃obt@m
      target = new StringBuffer(len);
    }
    boolean contains = false; //Ŝɒu݂邩̃tO
    boolean replace = false; //ꕶƂ̒uwtO
    int point = 0;
    //ꕶÂ
    while (point < len) {
      current = argOriginalString.charAt(point);
      //lQƕ̃`FbN
      if (current == '&' && (point + 3) < len && argOriginalString.charAt(point + 1) == '#') {
        int i1 = point + 2;
        char refer = argOriginalString.charAt(i1);
        boolean hex = false;
        //lQƕ16i\̃`FbN
        if (refer == 'x' || refer == 'X') {
          hex = true;
          i1++;
        }
        int code = 0;
        boolean error = true;
        //lQƃR[h̎擾
        while (i1 < len) {
          refer = argOriginalString.charAt(i1);
          if (refer == ';') {
            if (code > 0) {
              error = false;
            }
            break;
          }
          if (hex) {
            code *= 16;
          } else {
            code *= 10;
          }
          if (refer >= '0' && refer <= '9') {
            refer -= '0';
          } else if (hex) {
            if (refer >= 'a' && refer <= 'f') {
              refer -= 'a';
            } else if (refer >= 'A' && refer <= 'F') {
              refer -= 'A';
            } else {
              break;
            }
            refer += 10;
          } else {
            break;
          }
          code += (int)refer;
          if (code > 0xffff) {
            break;
          }
          i1++;
        }
        if (!error) {
          //lQƕo
          contains = true;
          current = (char)code;
          point = i1;
        }
      }
      //̒u𔻒肷
      replace = false;
      if (current > (char)0xff) {
        buffer = null;
        try {
          //Shift_JIS(MS9329)ɕϊ
          buffer = String.valueOf(current).getBytes("MS932");
        } catch (java.io.UnsupportedEncodingException ex) {
        }

        if (buffer == null || (buffer.length == 1 && buffer[0] == (byte)'?')) {
          //ϊɎs
          contains = true;
          replace = true;
        }
      }
      if (argReplaceCharacter != null) {
        if (replace) {
          target.append(argReplaceCharacter);
        } else {
          target.append(current);
        }
      } else {
        if (replace) break;
      }
      point++;
    }
    if (contains) {
      if (argReplaceCharacter != null) {
        return target.toString();
      } else {
        //uw肪ꍇɒu镶oꍇɂnullԂ
        return null;
      }
    }
    //uȂꍇ͌̂̕܂ܕԂ
    return argOriginalString;
  }

}
