package jp.co.nec.ome.utility;

import java.io.*;
import java.util.*;
import jp.co.nec.ome.text.*;

//*****************************************************************************
/**
 * i[f[^tB[hNXł<BR>
 * ݒlƂ<I>String</I>IuWFNg܂B<BR>
 * ݒlݒA擾A]郁\bh񋟂܂B<BR>
 * <I>OmFieldAttribute</I>NXȉ̑gĂ܂B<BR>
 * <UL>
 * <LI>Ɏgpł镶
 * <LI>̍ŏ
 * <LI>̍ő咷
 * </UL><P>
 * ȉ̏œݒl]܂B<BR>
 * <UL>
 * <LI>񂪐ݒ肳Ă邩
 * <LI>ɎgpĂ镶ʂ
 * <LI>񂪒ZȂ
 * <LI>񂪒Ȃ
 * </UL><P>
 * p̃G[nh<I>OmInvalidStringFieldValueHandler</I>ݒ肳Ă
 * ꍇ̓G[ɑΉG[nh̃\bhĂяo܂B<BR>
 * ̃oCgvZۂ͐ݒ肳ĂGR[fBOp
 * s܂B<BR>
 * GR[fBȌlƂăVXevpeB
 * <I>ome.EncodingForStringFieldLengthCount</I>ɐݒ肳Ăl
 * gp܂Aݒ肳ĂȂƂ MS932 ftHgƂĎgp܂B
 * <P>
 * JIS2004ǉȂǂ̃VtgJISŕ\łȂݒ肳ꂽꍇɂ́A
 * VXevpeB<I>ome.ReplaceNotSJISCharacter</I>
 * upݒ肷ΎIɂ̕ɒuĕێ܂B
 * <P>
 * <B>gp@F</B><BR>
 * <BLOCKQUOTE><PRE>
 * //iR[hi[tB[h쐬
 * OmStringFieldAttribute syohincd = new OmStringFieldAttribute();
 * //K{͐ݒ
 * syohincd.setNotNull(true);
 * //pp̂
 * syohincd.setCharacterType(OmStringFieldAttribute.TYPE_ALPHABET_NUMERIC);
 * //`FbNŃG[oƂ̏`
 * syohincd.setInvalidFieldValueHandler(new OmInvalidStringFieldValueHandler() {
 *   public void nullValue() {
 *     System.out.println("iR[h͕K{͍ڂłB");
 *   }
 *   public void invalidCharacterType() {
 *     System.out.println("gpł镶͔pp݂̂łB");
 *   }
 * });
 * </PRE></BLOCKQUOTE>
 * <P>
 * @author  Youichi Tokuda
 * @version $Revision:   5.11  $ $Date:   22 Mar 2007 18:14:02  $
 * @since   OpenMeisterEnterprise/EF 2.1
 */
//*****************************************************************************
public class OmStringFieldAttribute extends OmFieldAttribute {

  //***************************************************************************
  //萔
  //***************************************************************************

  /** Shift_JIS(MS932)ŕ\łȂ̒u\킷VXevpeB̃L[ */
  public static final String KEY_REPLACE_CHARACTER = "ome.ReplaceNotSJISCharacter";

  /** ftHgŎgpGR[fBO */
  public static final String DEFAULT_ENCODING = "MS932";

  /** ftHgŎgpGR[fBO\킷VXevpeB̃L[ */
  public static final String KEY_ENCODING = "ome.EncodingForStringFieldLengthCount";

  /** ʐȂ */
  public static final int TYPE_ANY = 0;

  /** ʔpp */
  public static final int TYPE_ALPHABET = 1;

  /** ʔp */
  public static final int TYPE_NUMERIC = 2;

  /** ʔpp */
  public static final int TYPE_ALPHABET_NUMERIC = TYPE_ALPHABET | TYPE_NUMERIC;

  /** ʔpJi */
  public static final int TYPE_KANA = 4;

  /** ʔppJi */
  public static final int TYPE_ANK = TYPE_ALPHABET_NUMERIC | TYPE_KANA;

  /** Shift-JIS 2oCg */
  public static final int TYPE_SJIS = 8;

  /** ʔpL */
  public static final int TYPE_SYMBOL = 16;

  /** ASCII */
  public static final int TYPE_ASCII = TYPE_ALPHABET_NUMERIC | TYPE_SYMBOL;

  /** G[ƂG[R[h */
  protected static final int ERROR_NONE = 0;

  /** 񂪐ݒ肳ĂȂƂG[R[h */
  protected static final int ERROR_NULL_VALUE = 1;

  /** ʂsł邱ƂG[R[h */
  protected static final int ERROR_INVALID_CHARACTER_TYPE = 2;

  /** ݒ肳ꂽ񂪒Z邱ƂG[R[h */
  protected static final int ERROR_TOO_SHORT = 3;

  /** ݒ肳ꂽ񂪒邱ƂG[R[h */
  protected static final int ERROR_TOO_LONG = 4;

  //***************************************************************************
  //protectedtB[h
  //***************************************************************************

  /** Shift_JIS̒up() */
  static protected String replaceNotSJISCharacter;

  /** tB[h̃LN^^ */
  protected int characterType = TYPE_ANY;

  /** tB[h̕񒷂̗̐L */
  protected boolean limitLength = false;

  /** tB[h̍ŏ */
  protected int minLength = 0;

  /** tB[h̍ő啶 */
  protected int maxLength = Integer.MAX_VALUE;

  /** tB[h̕l */
  protected String value;

  /** tB[h̕l̃oCg */
  protected int byteLength = 0;

  /** tB[h̕GR[fBO */
  protected String encoding;

  /**
   * ݒ莞̃gtOłB<BR>
   * setValue()\bhĂяoĕ񂪐ݒ肳ۂɎgp܂B<BR>
   */
  protected boolean trimValue = true;

  //***************************************************************************
  /**
   * i[f[^tB[hNX̏s܂B<BR>
   */
  //***************************************************************************
  static {
    //JIS2004ǉȂShift_JIS(MS932)ɕϊłȂ̒uݒ
    replaceNotSJISCharacter = System.getProperty(KEY_REPLACE_CHARACTER);
  }

  //***************************************************************************
  //RXgN^
  //***************************************************************************

  //***************************************************************************
  /**
   * lnullƂ
   * tB[h쐬܂B<BR>
   */
  //***************************************************************************
  public OmStringFieldAttribute() {
    value = null;
    setEncoding(System.getProperty(KEY_ENCODING, DEFAULT_ENCODING));
  }

  //***************************************************************************
  /**
   * lƂĕݒ肵ătB[h쐬܂B<BR>
   * gtO̓ftHgtrueƂȂAgꂽ񂪐ݒ肳܂B<BR>
   * @param argValue tB[h̏<BR>
   */
  //***************************************************************************
  public OmStringFieldAttribute(String argValue) {
    setValue(argValue);
    setEncoding(System.getProperty(KEY_ENCODING, DEFAULT_ENCODING));
  }

  //***************************************************************************
  /**
   * lƂĕƃgtOݒ肵ătB[h쐬܂B<BR>
   * @param argValue tB[h̏<BR>
   * @param argTrim gtO
   */
  //***************************************************************************
  public OmStringFieldAttribute(String argValue, boolean argTrim) {
    setTrim(argTrim);
    setValue(argValue);
    setEncoding(System.getProperty(KEY_ENCODING, DEFAULT_ENCODING));
  }

  //***************************************************************************
  //ANZX\bh
  //***************************************************************************

  //***************************************************************************
  /**
   * Ɏgpł镶ʂݒ肵܂B<BR>
   * ݒł͈̂ȉ̒lA͈ȉ̒l|(OR)̂łB<BR>
   * <BR>
   * Ȃ      TYPE_ANY<BR>
   * pp      TYPE_ALPHABET<BR>
   * p      TYPE_NUMERIC<BR>
   * pJi      TYPE_KANA<BR>
   * Sp      TYPE_SJIS<BR>
   * pp    TYPE_ALPHABET_NUMERIC (= TYPE_ALPHABET | TYPE_NUMERIC)<BR>
   * ppJiTYPE_ANK (= TYPE_ALPHABET_NUMERIC | TYPE_KANA)<BR>
   * pL      TYPE_SYMBOL<BR>
   * ASCII     TYPE_ASCII (=TYPE_ALPHABET_NUMERIC | TYPE_SYMBOL)<BR>
   *
   * @param argCharacterType <BR>
   */
  //***************************************************************************
  public void setCharacterType(int argCharacterType) {
    characterType = argCharacterType;
  }

  //***************************************************************************
  /**
   * Ɏgpł镶ʂ擾܂B<BR>
   *
   * @return <BR>
   */
  //***************************************************************************
  public int getCharacterType() {
    return characterType;
  }

  //***************************************************************************
  /**
   * ̒Ă邩擾܂B<BR>
   *
   * @return true:<BR>
   *         false:Ȃ
   */
  //***************************************************************************
  public boolean isLimitLength() {
    return limitLength;
  }

  //***************************************************************************
  /**
   * ̒̍ŏloCgTCYŎ擾܂B<BR>
   *
   * @return ̍ŏoCgTCY
   */
  //***************************************************************************
  public int getMinLength() {
    return minLength;
  }

  //***************************************************************************
  /**
   * ̒̍őloCgTCYŎ擾܂B<BR>
   *
   * @return ̍őoCgTCY
   */
  //***************************************************************************
  public int getMaxLength() {
    return maxLength;
  }

  //***************************************************************************
  /**
   * ݒ肵܂B<BR>
   * gtOtruȅꍇ́Agꂽ񂪐ݒ肳܂B<BR>
   * @param argValue ݒ肷镶
   */
  //***************************************************************************
  public void setValue(String argValue) {
    if (argValue != null && trimValue) {
      value = argValue.trim();
    } else {
      value = argValue;
    }
    //Shift_JIS(MS932)ŕ\łȂw蕶ɒu
    if (replaceNotSJISCharacter != null) {
      value = jp.co.nec.ome.text.OmStringFormat.replaceNotSJISCharacter(value, replaceNotSJISCharacter);
    }
  }

  //***************************************************************************
  /**
   * 擾܂B<BR>
   *
   * @return ݒ肳Ă镶
   */
  //***************************************************************************
  public String getValue() {
    return value;
  }

  //***************************************************************************
  /**
   * tB[h̕GR[fBOݒ肵܂B<BR>
   * ftHg "MS932" łB
   * ̐ݒ̓tB[hɐݒ肳ꂽ̃oCgvZۂ<BR>
   * p܂B
   *
   * @param argEncoding GR[fBO
   */
  //***************************************************************************
  public void setEncoding(String argEncoding) {
    encoding = argEncoding;
  }

  //***************************************************************************
  /**
   * tB[h̕GR[fBO擾܂B<BR>
   *
   * @return GR[fBO
   */
  //***************************************************************************
  public String getEncoding() {
    return encoding;
  }

  //***************************************************************************
  //public\bh
  //***************************************************************************

  //***************************************************************************
  /**
   * ̒𐧌܂B<BR>
   *
   * @param argMinLength ̍ŏ
   * @param argMaxLength ̍ő咷
   */
  //***************************************************************************
  public void limitLength(int argMinLength, int argMaxLength) {
    if (argMaxLength < argMinLength) {
      throw new IllegalArgumentException();
    }
    minLength = argMinLength;
    maxLength = argMaxLength;
    limitLength = true;
  }

  //***************************************************************************
  /**
   * ̒̍ŏ𐧌܂B<BR>
   *
   * @param argMinLength ̍ŏ
   */
  //***************************************************************************
  public void limitMinLength(int argMinLength) {
    if (maxLength < argMinLength) {
      throw new IllegalArgumentException();
    }
    minLength = argMinLength;
    limitLength = true;
  }

  //***************************************************************************
  /**
   * ̒̍ő咷𐧌܂B<BR>
   *
   * @param argMaxLength ̍ő咷
   */
  //***************************************************************************
  public void limitMaxLength(int argMaxLength) {
    if (argMaxLength < minLength) {
      throw new IllegalArgumentException();
    }
    maxLength = argMaxLength;
    limitLength = true;
  }

  //***************************************************************************
  /**
   * ̒𐧌܂B<BR>
   */
  //***************************************************************************
  public void unlimitLength() {
    minLength = 0;
    maxLength = Integer.MAX_VALUE;
    limitLength = false;
  }

  //***************************************************************************
  /**
   * ݒ肷ƂɑŐ󔒂邩ǂݒ肵܂B<BR>
   * @param argTrim <DL><DD>true : Ő󔒂
   *                    <DD>false: Ő󔒂Ȃ</DL>
   */
  //***************************************************************************
  public void setTrim(boolean argTrim) {
    trimValue = argTrim;
  }

  //***************************************************************************
  /**
   * ݒ肷ƂɑŐ󔒂邩ǂ擾܂B<BR>
   * @return <DL><DD>true : Ő󔒂
   *             <DD>false: Ő󔒂Ȃ</DL>
   */
  //***************************************************************************
  public boolean isTrim() {
    return trimValue;
  }

  //***************************************************************************
  /**
   * ݒ肳ꂽl̑ɑ΂Đ𔻒f܂B<BR>
   *
   * @return true:ݒl<BR>
   *         false:ݒls
   */
  //***************************************************************************
  public boolean validate() {
    int errorCode = internalValidate();
    if (errorCode == ERROR_NONE) return true;
    OmInvalidFieldValueHandler errorHandler = getInvalidFieldValueHandler();
    if (errorHandler != null) {
      if (errorCode == ERROR_NULL_VALUE) {
        errorHandler.nullValue();
      } else {
        if (errorHandler instanceof OmInvalidStringFieldValueHandler) {
          switch (errorCode) {
            case ERROR_INVALID_CHARACTER_TYPE:
              ((OmInvalidStringFieldValueHandler)errorHandler).invalidCharacterType();
              break;
            case ERROR_TOO_SHORT:
              ((OmInvalidStringFieldValueHandler)errorHandler).tooShort();
              break;
            case ERROR_TOO_LONG:
              ((OmInvalidStringFieldValueHandler)errorHandler).tooLong();
              break;
            default:
              errorHandler.invalidValue();
          }
        } else {
          errorHandler.invalidValue();
        }
      }
    }
    return false;
  }

  //***************************************************************************
  /**
   * {@link jp.co.nec.ome.text.OmNumberFormat}NX̃ftHgɂ
   * tH[}bgԋp܂B
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatNumber() {
    return OmNumberFormat.format(value);
  }

  //***************************************************************************
  /**
   * ^ꂽ{@link jp.co.nec.ome.text.OmNumberFormat}NXɈn
   * tH[}bgԋp܂B
   * @param argFormat (`{@link jp.co.nec.ome.text.OmNumberFormat}
   *                  NXQ)
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatNumber(String argFormat) {
    return OmNumberFormat.format(value, argFormat);
  }

  //***************************************************************************
  /**
   * ^ꂽA킹鐮
   * {@link jp.co.nec.ome.text.OmNumberFormat}NXɈntH[}bg
   * ԋp܂B
   * @param argFormat (`{@link jp.co.nec.ome.text.OmNumberFormat}
   *                  NXQ)
   * @param argIntegralNumber 킹鐮
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatNumber(String argFormat, int argIntegralNumber) {
    return OmNumberFormat.format(value, argFormat, argIntegralNumber);
  }

  //***************************************************************************
  /**
   * ^ꂽA킹鐮A킹鏬
   * {@link jp.co.nec.ome.text.OmNumberFormat}NXɈntH[}bg
   * ԋp܂B
   * @param argFormat (`{@link jp.co.nec.ome.text.OmNumberFormat}
   *                  NXQ)
   * @param argIntegralNumber 킹鐮
   * @param argDecimalNumber 킹鏬
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatNumber(String argFormat, int argIntegralNumber, int argDecimalNumber) {
    return OmNumberFormat.format(value, argFormat, argIntegralNumber, argDecimalNumber);
  }

  //***************************************************************************
  /**
   * ^ꂽA킹鐮A킹̗]
   * {@link jp.co.nec.ome.text.OmNumberFormat}NXɈntH[}bg
   * ԋp܂B
   * @param argFormat (`{@link jp.co.nec.ome.text.OmNumberFormat}
   *                  NXQ)
   * @param argIntegralNumber 킹鐮
   * @param argReplaceSpace 킹̗]
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatNumber(String argFormat, int argIntegralNumber, String argReplaceSpace) {
    return OmNumberFormat.format(value, argFormat, argIntegralNumber, -1, argReplaceSpace);
  }

  //***************************************************************************
  /**
   * ^ꂽA킹鐮A킹鏬A
   * 킹̗]{@link jp.co.nec.ome.text.OmNumberFormat}NX
   * ntH[}bgԋp܂B
   * @param argFormat (`{@link jp.co.nec.ome.text.OmNumberFormat}
   *                  NXQ)
   * @param argIntegralNumber 킹鐮
   * @param argDecimalNumber 킹鏬
   * @param argReplaceSpace 킹̗]
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatNumber(String argFormat, int argIntegralNumber, int argDecimalNumber, String argReplaceSpace) {
    return OmNumberFormat.format(value, argFormat, argIntegralNumber, argDecimalNumber, argReplaceSpace);
  }

  //***************************************************************************
  /**
   * {@link jp.co.nec.ome.text.OmDateFormat}NX̃ftHgɂ
   * tH[}bgԋp܂B
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatDate() {
    if (value == null || value.length() != 8) {
      return OmStringFormat.replaceTag(value);
    }
    OmDateContainer dateValue = new OmDateContainer();
    dateValue.setYear(value.substring(0, 4));
    dateValue.setMonth(value.substring(4, 6));
    dateValue.setDay(value.substring(6, 8));
    try {
      Date date = dateValue.getDate();
      if (date == null) {
        return OmStringFormat.replaceTag(value);
      }
    } catch (NumberFormatException ex) {
      return OmStringFormat.replaceTag(value);
    } catch (OmBadDateException ex) {
      return OmStringFormat.replaceTag(value);
    }
    return OmDateFormat.format(dateValue);
  }

  //***************************************************************************
  /**
   * ^ꂽ{@link jp.co.nec.ome.text.OmDateFormat}NXɈn
   * tH[}bgԋp܂B
   * @param argFormat (`{@link jp.co.nec.ome.text.OmDateFormat}
   *                  NXQ)
   * @return tH[}bg̕
   */
  //***************************************************************************
  public String formatDate(String argFormat) {
    if (value == null || value.length() != 8) {
      return OmStringFormat.replaceTag(value);
    }
    OmDateContainer dateValue = new OmDateContainer();
    dateValue.setYear(value.substring(0, 4));
    dateValue.setMonth(value.substring(4, 6));
    dateValue.setDay(value.substring(6, 8));
    try {
      Date date = dateValue.getDate();
      if (date == null) {
        return OmStringFormat.replaceTag(value);
      }
    } catch (NumberFormatException ex) {
      return OmStringFormat.replaceTag(value);
    } catch (OmBadDateException ex) {
      return OmStringFormat.replaceTag(value);
    }
    return OmDateFormat.format(dateValue, argFormat);
  }

  //***************************************************************************
  /**
   * uEUŕ\\ȕ\Œl擾ԋp܂B
   *
   * @return uEUŕ\\ȕ\̒l
   */
  //***************************************************************************
  public String toString() {
    return OmStringFormat.replaceTag(value);
  }

  //***************************************************************************
  //protected\bh
  //***************************************************************************

  //***************************************************************************
  /**
   * ݒ肳ꂽl̑ɑ΂Đ𔻒fG[R[h
   * Ԃ܂B<BR>
   *
   * @return G[R[h<BR>
   */
  //***************************************************************************
  protected int internalValidate() {
    if (!isNotNullValue()) {
      if (isNotNull()) {
      //K{͑Œlݒ肳ĂȂꍇ
        return ERROR_NULL_VALUE;
      }
    } else {
      if (!isValidCharacterType()) {
      //ݒ肳Ă镶ZbgȊO̕܂ޏꍇ
        return ERROR_INVALID_CHARACTER_TYPE;
      } else {
        if (isLimitLength()) { //񒷐ꍇ
          int byteSize = valueByteSize();
          if (byteSize < getMinLength()) {
            //񒷂ŏlꍇ
            return ERROR_TOO_SHORT;
          }
          if (byteSize > getMaxLength()) {
            //񒷂őlꍇ
            return ERROR_TOO_LONG;
          }
        }
      }
    }
    return ERROR_NONE;
  }

  //***************************************************************************
  /**
   * ^̓l̕ʂ̃`FbNs܂B<BR>
   * ݒ肳Ă镶ʈȊO̕܂ޏꍇ̓G[Ƃ܂B<BR>
   * null̏ꍇ true ԋpB
   *
   * @return true:`FbNOK<BR>
   *         false:`FbNNG
   */
  //***************************************************************************
  protected boolean isValidCharacterType() {
    if (getCharacterType() == TYPE_ANY) return true;
    if (!isNotNullValue()) return true;
    int length = value.length();
    for (int i1 = 0; i1 < length; i1++) {
      if ((getType(value.charAt(i1)) & getCharacterType()) == 0) {
        //w肳ꂽ^CvȊO̕܂ł
        return false;
      }
    }
    return true;
  }

  //***************************************************************************
  /**
   * ^ꂽ̎ʂR[hŕԂ܂B<BR>
   *
   * @param argCharacter ׂ镶
   * @return LN^[̎
   */
  //***************************************************************************
  protected int getType(char argCharacter) {
    byte[] sjisCharacter;
    try{
      //^ꂽShift-JISR[hɕϊ
      sjisCharacter = (new Character(argCharacter).toString()).getBytes("MS932");
    } catch (UnsupportedEncodingException ex) {
      return TYPE_ANY; //̑̕
    }
    if ((sjisCharacter.length == 2)) {
      return TYPE_SJIS; //Sp
    } else {
      int type = Character.getType(argCharacter);
      if (type == Character.OTHER_LETTER || type == Character.MODIFIER_LETTER) {
        return TYPE_KANA; //pJi
      } else if (Character.isDigit(argCharacter)) {
        return TYPE_NUMERIC; //
      } else if (Character.isLetter(argCharacter)) {
        return TYPE_ALPHABET; //p
      }
    }
    return TYPE_SYMBOL; //̑ASCII(pL)
  }

  //***************************************************************************
  /**
   * ^̓l̃oCgTCYԂ܂B<BR>
   * TCY͐ݒ肳Ă镶GR[fBOɈˑ܂B<BR>
   * sȕGR[fBOݒ肳Ăꍇ0Ԃ܂B
   *
   * @return oCgTCY
   */
  //***************************************************************************
  protected int valueByteSize() {
    int byteSize = 0;
    if (value != null) {
      try{
        byteSize = (value.getBytes(getEncoding())).length;
      } catch (UnsupportedEncodingException ex) {
      }
    }
    return byteSize;
  }

  //***************************************************************************
  /**
   * ̃tB[hɒlݒ肳Ă邩𒲂ׂ܂B<BR>
   *
   * @return true:lݒ肳Ă<BR>
   *         false:lݒ肳ĂȂ
   */
  //***************************************************************************
  protected boolean isNotNullValue() {
    if (value != null && value.length() > 0) {
      return true;
    }
    return false;
  }

}

